<?php
/**
*
* @package CPF Search v.0.1.2
* @version $Id: search_cpf.php 2356 2010-03-14 15:12:32Z 4seven $
* @copyright (c) 2011 / 4seven
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
if (!function_exists('get_user_avatar')){
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);} 

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/search_cpf');

// CPF Search / 4seven / 2011

/*
1 Numbers
2 Single text field, 
3 Textarea 
4 Boolean (Yes/No)
5 Dropdown box
6 Date
*/

if ($auth->acl_get('u_search')){

// group vars
$group_show_1_arr = request_var('cpf_group_1', '');
$group_show_1_req = request_var('cpf_group_1', array(0));
$group_show_1_lnk = implode(',', $group_show_1_req);

// var prevents
if(empty($group_show_1_req)){
$group_show_1_req = explode(',', $group_show_1_arr);}

if(empty($group_show_1_lnk)){
$group_show_1_lnk = $group_show_1_arr;}

		// sql for checking groups (cached)
		$sql = 'SELECT group_id, group_name 
		        FROM ' . GROUPS_TABLE . '
				WHERE group_name != "BOTS"
				AND group_name   != "GUESTS"';		
		$result = $db->sql_query($sql, 3600);
		
		while ($row = $db->sql_fetchrow($result)){
		
		$template->assign_block_vars('cpf_groups', array(
	        'CPF_GROUP_ID'         => $row['group_id'],
	        'CPF_GROUP_NAME'       => (isset($user->lang['G_' . $row['group_name']])) ? $user->lang['G_' . $row['group_name']] : $row['group_name'],
			'S_CPF_GROUP_REG_TRUE' => ($row['group_name'] == 'REGISTERED') ? true : false));
			}
		
		$db->sql_freeresult($result);

		// OPTIONS
		// Search in 'Field Type': Boolean (Yes/No) ? / Options: true or false
		$sql_bol_set  = true;
		// Search in 'Field Type': Dropdown box ? / Options: true or false
		$sql_drop_set = true;
		// Board Language ? / Options: true or false  (false > User Language) 
		$sql_lang_set = true;
		// OPTIONS

		// Table Converting for case in-sensitive searching
		/* ###############################
		utf8_unicode_ci is *generally* more accurate for all scripts.
		For example, on Cyrillic block:
		utf8_unicode_ci is fine for all these languages:
		Russian, Bulgarian, Belarusian, Macedonian, Serbian, and Ukrainian.
		While utf8_general_ci is fine only for Russian and Bulgarian subset of Cyrillic.
		Extra letters used in Belarusian, Macedonian, Serbian, and Ukrainian are sorted not well. 
		################ */
		
		$cpf_sel = (request_var('check', '') == 'utf8') ? true : false;
		
		if (($cpf_sel) && ($auth->acl_get('a_') && !empty($user->data['is_registered']))){
		$sql = 'ALTER TABLE ' . PROFILE_FIELDS_DATA_TABLE . '
		CONVERT TO CHARACTER SET utf8 
		COLLATE utf8_unicode_ci';
		$db->sql_query($sql);
		$utf8_true = true;}
	
		/* ################
		So change 
		COLLATE utf8_unicode_ci 
		to 
		COLLATE utf8_generale_ci
		if needed.
		Set
		COLLATE utf8_bin
		if your language have no classic upercase letters or it makes no sense for your needs
		################ */

		// MAIN CHECKS
		// sql for checking if text fields are present and active
		$sql = 'SELECT field_active
			    FROM ' . PROFILE_FIELDS_TABLE . ' 
			    WHERE field_active = 1
				AND field_searchable = 1
				AND field_show_profile = 1					
				AND field_type != 4
				AND field_type != 5 		
			    ORDER BY field_active';		
		$result = $db->sql_query($sql, 300);
		
		while ($row = $db->sql_fetchrow($result)){
		$count_active_fields[] = $row['field_active'];}
		
		$db->sql_freeresult($result);
		
		if (isset($count_active_fields)){
		$count_active_fields = true;}
		else{
		$count_active_fields = false;}
		// sql for checking if text fields are present and active
		
		// -----------------------------------------------------------------------
		
		// sql for checking if bool fields are present and active
		$sql = 'SELECT field_active
			    FROM ' . PROFILE_FIELDS_TABLE . ' 
			    WHERE field_active = 1
				AND field_searchable = 1
				AND field_show_profile = 1				
				AND (field_type = 4
				OR field_type = 5) 		
			    ORDER BY field_active';		
		$result = $db->sql_query($sql, 300);
		
		while ($row = $db->sql_fetchrow($result)){
		$count_active_options[] = $row['field_active'];}
		
		$db->sql_freeresult($result);
		
		if (isset($count_active_options)){
		$count_active_options = true;}
		else{
		$count_active_options = false;}
		// sql for checking if bool fields are present and active
		// MAIN CHECKS

		$template->assign_vars(array(
				'S_CPF_SEARCH_ACTION' => append_sid("{$phpbb_root_path}search_cpf.$phpEx"),
				'S_BOL_TEXT'          => (!$count_active_fields) ? false : true,
				'S_BOL_DROP'          => ((!$sql_bol_set &&  !$sql_drop_set) || !$count_active_options) ? false : true
		));

		// is anything out there?
		if ($count_active_fields || $count_active_options){ // new switch

		$start = request_var('start', 0);
		$limit = $config['posts_per_page'];

		// no result rows greater than 100 per page
		$limit = ($limit > 100) ? 100 : $limit;

		if($sql_lang_set){
		$config_default_lang = $config['default_lang'];}
		else{
		$config_default_lang = $user->data['user_lang'];}		

		// field type 4 +5 negation	
		$sql_bol_neg  = 'AND f.field_type != 4';
		$sql_drop_neg = 'AND f.field_type != 5';

		// field type 4 +5 
		$sql_bol  = (!$sql_bol_set)  ? 'AND f.field_type != 4' : '';
		$sql_drop = (!$sql_drop_set) ? 'AND f.field_type != 5' : '';

		// sql for building pulldown for main field types
		$sql = 'SELECT field_name, f.field_type, f.field_id, field_ident, field_length, field_required, lang_name, a.lang_id
			    FROM ' . PROFILE_FIELDS_TABLE . ' f, ' . PROFILE_LANG_TABLE . ' a, ' . LANG_TABLE . ' l
			    WHERE field_active = 1
				AND field_searchable = 1
				AND field_show_profile = 1
				' . $sql_bol_neg . '
				' . $sql_drop_neg . '
				AND f.field_id = a.field_id
				AND a.lang_id = l.lang_id 
				AND l.lang_iso = "' . $config_default_lang . '"				
			    ORDER BY field_order';
		$result = $db->sql_query($sql, 300);

		while ($row = $db->sql_fetchrow($result)){

		// switch for field types
		switch ($row['field_type']){
		case 1:
				$row['field_type'] = $user->lang['CPF_FIELD_INT'];
				break;
		case 2:
				$row['field_type'] = $user->lang['CPF_FIELD_STRING'];
				break;
		case 3:
				$row['field_type'] = $user->lang['CPF_FIELD_TEXT'];
				break;
		/*case 4:
				$row['field_type'] = $user->lang['CPF_FIELD_BOOL'];
				break;
		case 5:
				$row['field_type'] = $user->lang['CPF_FIELD_DROPDOWN'];
				break; */
		case 6:
				$row['field_type'] = $user->lang['CPF_FIELD_DATE'];
				break;}

				$template->assign_block_vars('profile_fields', array(
				'FIELD_NAME'	=> $row['lang_name'],
				'FIELD_TYPE_EX'	=> $row['field_type'],
				'FIELD_ID'		=>  'pf_' . $row['field_ident'],
				'S_REQUIRED'	=> ($row['field_required']) ? true : false,

				));}

		$db->sql_freeresult($result);

			// engine for results in board- or user-language
			$sql = 'SELECT field_ident, lang_value, lang_name, option_id
				FROM ' . PROFILE_FIELDS_TABLE . ' ft, ' . PROFILE_FIELDS_LANG_TABLE . ' f, ' . PROFILE_LANG_TABLE . ' a, ' . LANG_TABLE . ' l 
					WHERE ft.field_active = 1
					AND field_searchable = 1
				    AND field_show_profile = 1
					AND f.field_id = a.field_id
					AND ft.field_id = a.field_id
					AND f.lang_id = l.lang_id
					AND l.lang_id = a.lang_id					
					AND l.lang_iso = "' . $config_default_lang . '"	
					' . $sql_bol . '
				    ' . $sql_drop . '
				ORDER BY lang_name, option_id';
			$result = $db->sql_query($sql, 300);

			while ($row = $db->sql_fetchrow($result)){

				$template->assign_block_vars('option_fields', array(
				'SEARCH_ACTION' => append_sid("{$phpbb_root_path}search_cpf.$phpEx", 'cpf_select=' . ('pf_' . $row['field_ident']) . '&amp;' . 'cpf_search=' . ($row['option_id'] + 1)),
				'FIELD_ID'		=> 'pf_' . $row['field_ident'],
				'LANG_NAME'	    => $row['lang_name'],
				'OPTION_ID'	    => $row['option_id'] + 1,
				'LANG_VALUE'	=> $row['lang_value'],));}

			$db->sql_freeresult($result);	

		// request vars
		$cpf_select	= request_var('cpf_select', '');
		$cpf_name	= (!empty($cpf_select)) ? str_replace('pf_', '', $cpf_select) : '';
		$cpf_search	= utf8_normalize_nfc(request_var('cpf_search', '', true));

        if ($cpf_select){
		$template->assign_var('S_CPF_DISPLAY' , true);}

		// dont fill if empty
        if (!empty($cpf_select) && !empty($cpf_search)){

		// only if field type 4 or 5 and if active anyway
		if(($sql_bol_set || $sql_drop_set) && $count_active_options){

		// first lang name stage + one and only lang value
		$sql = 'SELECT lang_value, a.lang_name
			    FROM ' . PROFILE_FIELDS_TABLE . ' f, ' . PROFILE_FIELDS_LANG_TABLE . ' pl, ' . PROFILE_LANG_TABLE . ' a, ' . LANG_TABLE . ' l
			    WHERE f.field_name = "' . $cpf_name . '"
				AND f.field_active = 1
				AND field_searchable = 1
				AND field_show_profile = 1			
				AND f.field_id = pl.field_id
                AND f.field_id = a.field_id				
				AND pl.option_id = ' . ((is_numeric($cpf_search)) ? ($cpf_search - 1) : 0) . '
				AND pl.lang_id = a.lang_id 				
				AND a.lang_id = l.lang_id 
				AND l.lang_iso = "' . $config_default_lang . '"				
			    ORDER BY pl.option_id';
		$result1 = $db->sql_query($sql, 300);
		$row1 = $db->sql_fetchrow($result1);
		$db->sql_freeresult($result1);

		$row_lang_name  = (!empty($row1['lang_name'])) ? $row1['lang_name'] : '';
		$row_lang_value = (!empty($row1['lang_value'])) ? $row1['lang_value'] : '';}

		// second lang name stage
		$sql = 'SELECT lang_name
			    FROM ' . PROFILE_FIELDS_TABLE . ' f, ' . PROFILE_LANG_TABLE . ' a, ' . LANG_TABLE . ' l
			    WHERE f.field_name = "' . $cpf_name . '"
				AND f.field_active = 1
				AND field_searchable = 1			
				AND field_show_profile = 1
                AND f.field_id = a.field_id
				AND a.lang_id = l.lang_id
				AND l.lang_iso = "' . $config_default_lang . '"
			    ORDER BY f.field_name';
		$result2 = $db->sql_query_limit($sql, 300);
		$row2 = $db->sql_fetchrow($result2);
		$db->sql_freeresult($result2);

		$row_lang_name  = (!empty($row2['lang_name'])) ? $row2['lang_name'] : '';

	   			$template->assign_vars(array(
				'CPF_NAME'	   => $row_lang_name,
				'CPF_TERM'	   => (!empty($row_lang_value)) ? $row_lang_value : $cpf_search,
				'S_CPF_RESULT' => true));

		// search only if filled
		$sql_where_cpf  = '';
		$sql_where_cpf .= "*$cpf_search*";

		// build main request sql where
		$sql_where_add  = ($cpf_select) ? ' AND ' . $cpf_select . ' ' . $db->sql_like_expression(str_replace('*', $db->any_char, $db->sql_escape($sql_where_cpf))) : '';
		
		// result order
		$cpf_resord	= request_var('res_ord', '');		
		$cpf_resord = (int) $cpf_resord;

		// generate pagination url
		$pagination_url = append_sid("{$phpbb_root_path}search_cpf.$phpEx", 'cpf_select='  . $cpf_select . '&amp;cpf_search=' . $cpf_search . '&amp;res_ord=' . $cpf_resord . '&amp;cpf_group_1=' . $group_show_1_lnk);

		 switch($cpf_resord){
		    case 1:
		        $cpf_re_ord      = 'user_regdate DESC';
				$cpf_re_ord_lang = 'ORDER_REGDATE';
		        break;
		    case 2:
		        $cpf_re_ord      = 'u.username';
				$cpf_re_ord_lang = 'ORDER_USERNAME';				
		        break;
		    case 3:
		        $cpf_re_ord      = 'd.user_id';
				$cpf_re_ord_lang = 'ORDER_USER_ID';
		        break;	
			default:
                $cpf_re_ord      = 'u.username';
				$cpf_re_ord_lang = 'ORDER_USERNAME';
				}

	   	$template->assign_var('CPF_RES_ORDER_LANG', $user->lang['CPF_' . $cpf_re_ord_lang]);

		// build sql query
		$sql_ary = array(
	   			'SELECT'    => 'group_name, d.user_id, ' . $cpf_select . ', username, user_colour, user_avatar, user_avatar_type, user_avatar_width, user_avatar_height',
	   			'FROM'      => array(
				GROUPS_TABLE              => 'gr',
	   			PROFILE_FIELDS_DATA_TABLE => 'd',
	   			USERS_TABLE               => 'u',
	   			USER_GROUP_TABLE          => 'g',
	   			),
	   			'WHERE'     => 	'd.user_id = u.user_id
				                 AND d.user_id = g.user_id
								 AND g.group_id = gr.group_id
				                 AND ' . $db->sql_in_set('g.group_id', $group_show_1_req) . $sql_where_add,
								 
	   			'ORDER_BY'  => $cpf_re_ord

	   			);

		// generate row limit
		$sql = $db->sql_build_query('SELECT', $sql_ary);
		$result = $db->sql_query_limit($sql, $limit, $start);

		while ($row = $db->sql_fetchrow($result)){

		// lang value only if filled
		if (isset($row_lang_value) && !empty($row_lang_value)){	
		$row["$cpf_select"] = $row_lang_value;}

	   			$template->assign_block_vars('cpf_results', array(
				'CPF_GROUPNAME'	=> (isset($user->lang['G_' . $row['group_name']])) ? $user->lang['G_' . $row['group_name']] : $row['group_name'],
				'U_CPF_PROFILE'	=> append_sid("{$phpbb_root_path}memberlist.$phpEx", 'mode=viewprofile&amp;u=' . $row['user_id']),
				'CPF_AVATAR'	=> get_user_avatar($row['user_avatar'], $row['user_avatar_type'], $row['user_avatar_width'], $row['user_avatar_height'], $alt = 'USER_AVATAR', $ignore_config = false),
				'CPF_USERNAME'	=> get_username_string('full', $row['user_id'], $row['username'], $row['user_colour']),
				'CPF_SELECT'	=> $row["$cpf_select"]
				));

				$row_group_name[] = (isset($user->lang['G_' . $row['group_name']])) ? $user->lang['G_' . $row['group_name']] : $row['group_name'];
				$row_user_id[]    = $row['user_id'];
				$cpf_results[]    = $row["$cpf_select"];}

		$db->sql_freeresult($result);

		// now we run the query again to get the total rows...
		// the query is identical except we count the rows instead
		$sql_ary['SELECT'] = 'COUNT(d.user_id) as total_counts';
		$sql = $db->sql_build_query('SELECT', $sql_ary);
		$result = $db->sql_query($sql);

		// get the total users, this is a single row, single field.
		$cpf_counts = $db->sql_fetchfield('total_counts');
		
		// free the result
		$db->sql_freeresult($result);

		
		$template->assign_var('CPF_RESULT_COUNT', (isset($cpf_results)) ? $cpf_counts : 0);

		// Assign the pagination variables to the template.
		$template->assign_vars(array(
				'PAGINATION'  => generate_pagination($pagination_url, $cpf_counts, $limit, $start),
				'TOTAL_RES'   => ($cpf_counts == 1) ? $user->lang['CPF_RESULT'] : sprintf($user->lang['CPF_RESULTS'], $cpf_counts),
				'PAGE_NUMBER' => on_page($cpf_counts, $limit, $start),
		));
	
		// sql for checking if text fields are present and active
		$sql = 'SELECT group_name 
		        FROM ' . GROUPS_TABLE . '
				WHERE ' . $db->sql_in_set('group_id', $group_show_1_req);		
		$result = $db->sql_query($sql, 3600);
		
		while ($row = $db->sql_fetchrow($result)){
		
		$template->assign_block_vars('cpf_group_result', array(
	        'CPF_GROUP_NAME'       => (isset($user->lang['G_' . $row['group_name']])) ? $user->lang['G_' . $row['group_name']] : $row['group_name']
			));}
		
		$db->sql_freeresult($result);		

// show all cpf, except the one you find ;)
if (isset($row_user_id)){

include($phpbb_root_path . 'includes/functions_profile_fields.' . $phpEx);
		
$row_user_it = array_flip($row_user_id);	
	
$cp        = new custom_profile();		
$cp_row    = array();

foreach ($row_user_id as $row_user){

$full_prof = '';	
$profile_fields_cache = $cp->generate_profile_fields_template('grab', $row_user);

$cp_row    = (isset($profile_fields_cache[$row_user])) ? $cp->generate_profile_fields_template('show', false, $profile_fields_cache[$row_user]) : array();	

for ($i = 0, $end = sizeof($cp_row['blockrow']); $i < $end; ++$i){
$full_prof   .= ($row_lang_name !== $cp_row['blockrow'][$i]["PROFILE_FIELD_NAME"]) ? '<span style="font-weight:bold;">' . $cp_row['blockrow'][$i]["PROFILE_FIELD_NAME"] . ':</span> ' . $cp_row['blockrow'][$i]["PROFILE_FIELD_VALUE"] . '<br />' : '';
}

$template->alter_block_array('cpf_results', array(

'CPF_SELECT_AL'	  => '<br /><br />' . $full_prof,
'S_CPF_SELECT_AL' => (!empty($full_prof)) ? true : false

), $row_user_it[$row_user], 'change');

unset($full_prof);}}
		
}	
		
} // new switch

if (isset($utf8_true)){
$template->assign_var('UTF8_TRUE', (($utf8_true) ? true : false));}

// template output
page_header($user->lang['CPF_SEARCH']);

$template->set_filenames(array(
'body' => 'search_cpf.html'));

page_footer();}

else{
trigger_error('NO_SEARCH');}

// CPF Search / 4seven / 2011

?>